=== debian/changelog ===
osmcoastline (2.4.1-1build1) resolute; urgency=medium

  * No-change rebuild for libgdal37.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 30 Oct 2025 20:54:24 +0000

osmcoastline (2.4.1-1) unstable; urgency=medium

  * New upstream release.
  * Use execute_after instead of override in rules file.
  * Enable Salsa CI.
  * Drop unused libspatialite-dev build dependency.
  * Bump Standards-Version to 4.7.0, no changes.
  * Update copyright file.
  * Drop gdal-3.7.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 14 Jan 2025 12:53:34 +0100
