=== debian/changelog ===
osmcoastline (2.5.0-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.
  * Update branch in gbp.conf & Vcs-Git URL.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 24 Jan 2026 09:06:38 +0100

osmcoastline (2.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes.
  * Fix old FSF address in copyright file.
  * Update lintian overrides.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Use test-build-validate-cleanup instead of test-build-twice.
  * Drop Priority: optional, default since dpkg 1.22.13.
  * Annotate build dependencies with nodoc.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Jan 2026 18:50:36 +0100
