=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Bas Couwenberg <sebastic@debian.org>
 Section: science
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libbz2-dev,
@@ -11,15 +10,14 @@
                libgeos++-dev,
                libosmium2-dev (>= 2.16.0),
                libgdalcpp-dev,
-               pandoc,
+               pandoc <!nodoc>,
                spatialite-bin,
                sqlite3,
                zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osmcoastline
-Vcs-Git: https://salsa.debian.org/debian-gis-team/osmcoastline.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/osmcoastline.git -b trixie-backports
 Homepage: https://osmcode.org/osmcoastline/
-Rules-Requires-Root: no
 
 Package: osmcoastline
 Architecture: any
